﻿Imports System.Text

Public Class Form1

    Declare Function PostMessage Lib "USER32" Alias "PostMessageA" (ByVal hwnd As IntPtr, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As Integer) As Integer
    Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As IntPtr) As Integer
    Declare Function SetFocus Lib "user32" Alias "SetFocus" (ByVal hwnd As IntPtr) As Integer

    Const WM_COMMAND As Integer = &H111
    Const WM_SETTEXT As Integer = &HC

#Region "Pal 10 Control defaults"

    Public ReadOnly Property ChatRoomClass() As String
        Get
            Return "DlgGroupChat Window Class"
        End Get
    End Property

    Public ReadOnly Property NicListClass() As String
        Get
            Return "SysListView32"
        End Get
    End Property

    Public ReadOnly Property NicListIndex() As Integer
        Get
            Return 1
        End Get
    End Property

    Public ReadOnly Property BounceWindowClass() As String
        Get
            Return "#32770"
        End Get
    End Property

    Public ReadOnly Property BounceReasonClass() As String
        Get
            Return "Edit"
        End Get
    End Property

    Public ReadOnly Property ButtonClass() As String
        Get
            Return "Button"
        End Get
    End Property

    Public ReadOnly Property BounceReasonIndex() As Integer
        Get
            Return 1
        End Get
    End Property

    Public ReadOnly Property BounceCloseIndex() As Integer
        Get
            Return 1
        End Get
    End Property

    Public ReadOnly Property BounceCommand() As Integer
        Get
            Return 32947
        End Get
    End Property

#End Region

#Region "Nic Subs & Functions"

    Private Function HighlightNic(ByVal sNic As String) As Boolean
        ' Get nic list handle
        Dim iHnd As IntPtr = mdlHnd.GetChild(ChatRoomClass, Me.CtrlRoomSelector1.RoomName, NicListClass, NicListIndex)
        ' Only process if nic list found
        If iHnd <> IntPtr.Zero Then
            Dim iResult As Integer
            ' Bring pal room to top window
            iResult = SetForegroundWindow(iHnd)
            ' Set focus on nic list
            iResult = SetFocus(iHnd)
            ' Process each letter in nic
            For iCharIndex As Integer = 0 To sNic.Length - 1
                ' Get current letter in nic to process
                Dim cCurLetter As String = sNic.Chars(iCharIndex)
                ' Sent character to nic list
                Select Case cCurLetter.ToUpper
                    Case "A"
                        keybd_event(VK_A, MapVirtualKey(VK_A, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_A, MapVirtualKey(VK_A, 0), KEYEVENTF_KEYUP, 0)
                    Case "B"
                        keybd_event(VK_B, MapVirtualKey(VK_B, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_B, MapVirtualKey(VK_B, 0), KEYEVENTF_KEYUP, 0)
                    Case "C"
                        keybd_event(VK_C, MapVirtualKey(VK_C, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_C, MapVirtualKey(VK_C, 0), KEYEVENTF_KEYUP, 0)
                    Case "D"
                        keybd_event(VK_D, MapVirtualKey(VK_D, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_D, MapVirtualKey(VK_D, 0), KEYEVENTF_KEYUP, 0)
                    Case "E"
                        keybd_event(VK_E, MapVirtualKey(VK_E, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_E, MapVirtualKey(VK_E, 0), KEYEVENTF_KEYUP, 0)
                    Case "F"
                        keybd_event(VK_F, MapVirtualKey(VK_F, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_F, MapVirtualKey(VK_F, 0), KEYEVENTF_KEYUP, 0)
                    Case "G"
                        keybd_event(VK_G, MapVirtualKey(VK_G, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_G, MapVirtualKey(VK_G, 0), KEYEVENTF_KEYUP, 0)
                    Case "H"
                        keybd_event(VK_H, MapVirtualKey(VK_H, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_H, MapVirtualKey(VK_H, 0), KEYEVENTF_KEYUP, 0)
                    Case "I"
                        keybd_event(VK_I, MapVirtualKey(VK_I, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_I, MapVirtualKey(VK_I, 0), KEYEVENTF_KEYUP, 0)
                    Case "J"
                        keybd_event(VK_J, MapVirtualKey(VK_J, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_J, MapVirtualKey(VK_J, 0), KEYEVENTF_KEYUP, 0)
                    Case "K"
                        keybd_event(VK_K, MapVirtualKey(VK_K, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_K, MapVirtualKey(VK_K, 0), KEYEVENTF_KEYUP, 0)
                    Case "L"
                        keybd_event(VK_L, MapVirtualKey(VK_L, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_L, MapVirtualKey(VK_L, 0), KEYEVENTF_KEYUP, 0)
                    Case "M"
                        keybd_event(VK_M, MapVirtualKey(VK_M, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_M, MapVirtualKey(VK_M, 0), KEYEVENTF_KEYUP, 0)
                    Case "N"
                        keybd_event(VK_N, MapVirtualKey(VK_N, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_N, MapVirtualKey(VK_N, 0), KEYEVENTF_KEYUP, 0)
                    Case "O"
                        keybd_event(VK_O, MapVirtualKey(VK_O, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_O, MapVirtualKey(VK_O, 0), KEYEVENTF_KEYUP, 0)
                    Case "P"
                        keybd_event(VK_P, MapVirtualKey(VK_P, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_P, MapVirtualKey(VK_P, 0), KEYEVENTF_KEYUP, 0)
                    Case "Q"
                        keybd_event(VK_Q, MapVirtualKey(VK_Q, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_Q, MapVirtualKey(VK_Q, 0), KEYEVENTF_KEYUP, 0)
                    Case "R"
                        keybd_event(VK_R, MapVirtualKey(VK_R, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_R, MapVirtualKey(VK_R, 0), KEYEVENTF_KEYUP, 0)
                    Case "S"
                        keybd_event(VK_S, MapVirtualKey(VK_S, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_S, MapVirtualKey(VK_S, 0), KEYEVENTF_KEYUP, 0)
                    Case "T"
                        keybd_event(VK_T, MapVirtualKey(VK_T, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_T, MapVirtualKey(VK_T, 0), KEYEVENTF_KEYUP, 0)
                    Case "U"
                        keybd_event(VK_U, MapVirtualKey(VK_U, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_U, MapVirtualKey(VK_U, 0), KEYEVENTF_KEYUP, 0)
                    Case "V"
                        keybd_event(VK_V, MapVirtualKey(VK_V, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_V, MapVirtualKey(VK_V, 0), KEYEVENTF_KEYUP, 0)
                    Case "W"
                        keybd_event(VK_W, MapVirtualKey(VK_W, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_W, MapVirtualKey(VK_W, 0), KEYEVENTF_KEYUP, 0)
                    Case "X"
                        keybd_event(VK_X, MapVirtualKey(VK_X, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_X, MapVirtualKey(VK_X, 0), KEYEVENTF_KEYUP, 0)
                    Case "Y"
                        keybd_event(VK_Y, MapVirtualKey(VK_Y, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_Y, MapVirtualKey(VK_Y, 0), KEYEVENTF_KEYUP, 0)
                    Case "Z"
                        keybd_event(VK_Z, MapVirtualKey(VK_Z, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_Z, MapVirtualKey(VK_Z, 0), KEYEVENTF_KEYUP, 0)
                    Case "0"
                        keybd_event(VK_0, MapVirtualKey(VK_0, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_0, MapVirtualKey(VK_0, 0), KEYEVENTF_KEYUP, 0)
                    Case "1"
                        keybd_event(VK_1, MapVirtualKey(VK_1, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_1, MapVirtualKey(VK_1, 0), KEYEVENTF_KEYUP, 0)
                    Case "2"
                        keybd_event(VK_2, MapVirtualKey(VK_2, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_2, MapVirtualKey(VK_2, 0), KEYEVENTF_KEYUP, 0)
                    Case "3"
                        keybd_event(VK_3, MapVirtualKey(VK_3, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_3, MapVirtualKey(VK_3, 0), KEYEVENTF_KEYUP, 0)
                    Case "4"
                        keybd_event(VK_4, MapVirtualKey(VK_4, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_4, MapVirtualKey(VK_4, 0), KEYEVENTF_KEYUP, 0)
                    Case "5"
                        keybd_event(VK_5, MapVirtualKey(VK_5, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_5, MapVirtualKey(VK_5, 0), KEYEVENTF_KEYUP, 0)
                    Case "6"
                        keybd_event(VK_6, MapVirtualKey(VK_6, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_6, MapVirtualKey(VK_6, 0), KEYEVENTF_KEYUP, 0)
                    Case "7"
                        keybd_event(VK_7, MapVirtualKey(VK_7, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_7, MapVirtualKey(VK_7, 0), KEYEVENTF_KEYUP, 0)
                    Case "8"
                        keybd_event(VK_8, MapVirtualKey(VK_8, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_8, MapVirtualKey(VK_8, 0), KEYEVENTF_KEYUP, 0)
                    Case "9"
                        keybd_event(VK_9, MapVirtualKey(VK_9, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_9, MapVirtualKey(VK_9, 0), KEYEVENTF_KEYUP, 0)
                    Case "_"
                        keybd_event(VK_UNDERSCORE, MapVirtualKey(VK_UNDERSCORE, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_UNDERSCORE, MapVirtualKey(VK_UNDERSCORE, 0), KEYEVENTF_KEYUP, 0)
                    Case " "
                        keybd_event(VK_SPACE, MapVirtualKey(VK_SPACE, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_SPACE, MapVirtualKey(VK_SPACE, 0), KEYEVENTF_KEYUP, 0)
                    Case "-"
                        keybd_event(VK_DASH, MapVirtualKey(VK_DASH, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_DASH, MapVirtualKey(VK_DASH, 0), KEYEVENTF_KEYUP, 0)
                    Case "$"
                        keybd_event(VK_DOLLAR, MapVirtualKey(VK_DOLLAR, 0), KEYEVENTF_KEYDOWN, 0)
                        keybd_event(VK_DOLLAR, MapVirtualKey(VK_DOLLAR, 0), KEYEVENTF_KEYUP, 0)
                End Select
            Next
            System.Threading.Thread.Sleep(100)
            If FindNic.ToLower = sNic.ToLower Then
                Return True
            Else
                Return False
            End If
        Else
            ' nic list not found
            Return False
        End If
    End Function

    Private Function FindNic() As String
        Dim iHnd As IntPtr = mdlHnd.GetChild(ChatRoomClass, Me.CtrlRoomSelector1.RoomName, NicListClass, NicListIndex)
        Return mdlSysListView.GetSLVSelectedItem(iHnd)
    End Function

    Private Sub BounceNic(ByVal sNic As String, ByVal sReason As String)
        ' highlight desired nic
        If HighlightNic(sNic) Then
            ' nic was highlighted so
            Bounce(sReason)
        End If
    End Sub

    Private Sub Bounce(ByVal sReason As String)
        Dim iResult As Integer
        ' Get room handle
        Dim hWndRoom As IntPtr = FindMainWindow(ChatRoomClass, Me.CtrlRoomSelector1.RoomName)
        ' Open Bounce
        iResult = PostMessage(hWndRoom, WM_COMMAND, BounceCommand, 0)
        ' wait for bounce window to open
        System.Threading.Thread.Sleep(500)

        ' Get Bounce Window handle
        Dim hWndBounce As IntPtr = mdlHnd.FindMainWindow(BounceWindowClass, "Ready to bounce:")

        ' Fill Bounce Reason
        Dim hWndReason As IntPtr = mdlHnd.GetChild(hWndBounce, BounceReasonClass, BounceReasonIndex)
        iResult = SendMessageA(hWndReason, WM_SETTEXT, 0, sReason)

        ' Close Bounce Reason
        Dim hWndClose = mdlHnd.GetChild(hWndBounce, ButtonClass, BounceCloseIndex)
        iResult = SendMessageA(hWndClose, WM_KEYDOWN, VK_SPACE, 0)
        iResult = SendMessageA(hWndClose, WM_KEYUP, VK_SPACE, 0)
    End Sub

#End Region

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        ' Set up room selector
        Me.CtrlRoomSelector1.ConnToCaption("Connect to:", False)
        Me.CtrlRoomSelector1.SetWinClass(ChatRoomClass)
    End Sub

    Private Sub btnBounce_Click(sender As System.Object, e As System.EventArgs) Handles btnBounce.Click
        ' Only process if nic is supplied
        If Not String.IsNullOrEmpty(tbNicToBounce.Text) Then
            BounceNic(tbNicToBounce.Text, "idiot")
        End If
    End Sub

    Private Sub btnQuickBounce_Click(sender As System.Object, e As System.EventArgs) Handles btnQuickBounce.Click
        Bounce("idiot")
    End Sub
End Class
